import { renderless, api } from "@dftvue2-opentiny/vue-renderless/year-table/vue";
import { isDate } from "@dftvue2-opentiny/vue-renderless/common/deps/date-util";
import { defineComponent, $prefix, setup as _setup } from "@dftvue2-opentiny/vue-common";
function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  if (functionalTemplate) {
    options.functional = true;
  }
  if (scopeId) {
    options._scopeId = "data-v-" + scopeId;
  }
  var hook;
  if (moduleIdentifier) {
    hook = function hook2(context) {
      context = context || // cached call
      this.$vnode && this.$vnode.ssrContext || // stateful
      this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext;
      if (!context && typeof __VUE_SSR_CONTEXT__ !== "undefined") {
        context = __VUE_SSR_CONTEXT__;
      }
      if (injectStyles) {
        injectStyles.call(this, context);
      }
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier);
      }
    };
    options._ssrRegister = hook;
  } else if (injectStyles) {
    hook = shadowMode ? function() {
      injectStyles.call(this, (options.functional ? this.parent : this).$root.$options.shadowRoot);
    } : injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

import "@dftvue2-opentiny/vue-theme/year-table/index.css";
var __vue2_script = defineComponent({
  name: $prefix + "YearTable",
  emits: ["pick"],
  props: {
    disabledDate: {},
    value: {},
    defaultValue: {
      validator: function validator(val) {
        return val === null || val instanceof Date && isDate(val);
      }
    },
    date: [Date, Array],
    selectionMode: String,
    startYear: Number,
    maxDate: {},
    minDate: {},
    rangeState: {
      default: function _default() {
        return {
          endDate: null,
          selecting: false
        };
      }
    }
  },
  setup: function setup(props, context) {
    return _setup({
      props,
      context,
      renderless,
      api,
      mono: true
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("table", {
    staticClass: "tiny-year-table",
    on: {
      "mousemove": _vm.handleMouseMove,
      "click": _vm.handleYearTableClick
    }
  }, [_c("tbody", _vm._l(_vm.state.rows, function(row, key) {
    return _c("tr", {
      key
    }, _vm._l(row, function(cell, key2) {
      return _c("td", {
        key: key2,
        staticClass: "available",
        class: _vm.getCellStyle(cell)
      }, [_c("div", [_c("a", {
        staticClass: "cell"
      }, [_vm._v(_vm._s(cell.text))])])]);
    }), 0);
  }), 0)]);
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles, null, null, null);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var YearTable = /* @__PURE__ */ function() {
  return __component__.exports;
}();
var version = "2.8.0";
YearTable.install = function(Vue) {
  Vue.component(YearTable.name, YearTable);
};
YearTable.version = version;
export {
  YearTable as default
};
